#ifndef __FATOLRGCONVERTER_H__
#define __FATOLRGCONVERTER_H__

#include <map>

#include <grammar/Regular/LeftRegularGrammar.h>
#include <automaton/FSM/FSM.h>
#include <AlibException.h>

#include "../../interface/IConversionLRG.h"
#include "../../include/macros.h"

namespace conversions
{

/**
 * Finite automaton to right regular grammar converter.
 * Source: My own :)
 */
class FAtoLRGConverter: public IConversionLRG
{
public:
    /**
     * @param automaton Original automaton.
     */
    FAtoLRGConverter( const automaton::FSM & automaton );

    ~FAtoLRGConverter( void );

    /**
     * Performs conversion.
     * @return left regular grammar equivalent to source automaton.
     */
    grammar::LeftRegularGrammar convert( void );

protected:
    /**
     * input automaton
     */
    const automaton::FSM & m_automaton;
};

} /* namespace conversions */

#endif /* __FATOLRGCONVERTER_H__ */
