/*
 * LeftToRightRegularGrammar.h
 *
 *  Created on: 8. 3. 2014
 *      Author: tomas
 */

#ifndef LEFTTORIGHTREGULARGRAMMAR_H_
#define LEFTTORIGHTREGULARGRAMMAR_H_

#include <grammar/Regular/LeftRegularGrammar.h>
#include <grammar/Regular/RightRegularGrammar.h>

#include "../../interface/IConversionRRG.h"

namespace conversions
{

class LeftToRightRegularGrammar: public IConversionRRG
{
public:
    /**
     * @param lrg Original left regular grammar.
     */
    LeftToRightRegularGrammar( const grammar::LeftRegularGrammar & lrg );

    virtual ~LeftToRightRegularGrammar( void );

    /**
     * Performs conversion.
     * @return right regular grammar which is equivalent to source left regular grammar.
     */
    grammar::RightRegularGrammar convert( void );

protected:
    /**
     * input grammar
     */
    const grammar::LeftRegularGrammar & m_lrg;
};

} /* namespace conversions */

#endif /* LEFTTORIGHTREGULARGRAMMAR_H_ */
