/*
 * RightToLeftRegularGrammar.h
 *
 *  Created on: 8. 3. 2014
 *      Author: tomas
 */

#ifndef RIGHTTOLEFTREGULARGRAMMAR_H_
#define RIGHTTOLEFTREGULARGRAMMAR_H_

#include <grammar/Regular/LeftRegularGrammar.h>
#include <grammar/Regular/RightRegularGrammar.h>

#include "../../interface/IConversionLRG.h"

namespace conversions
{

/**
 * Converts right regular grammar to left regular grammar.
 */
class RightToLeftRegularGrammar: public IConversionLRG
{
public:
    /**
     * @param rrg Original right regular grammar.
     */
    RightToLeftRegularGrammar( const grammar::RightRegularGrammar & rrg );

    virtual ~RightToLeftRegularGrammar( void );

    /**
     * Performs conversion.
     * @return left regular grammar which is equivalent to source right regular grammar.
     */
    grammar::LeftRegularGrammar convert( void );

private:
    /**
     *
     */
     const grammar::RightRegularGrammar & m_rrg;
};

} /* namespace conversions */

#endif /* RIGHTTOLEFTREGULARGRAMMAR_H_ */
