/*
 * GlushkovSymbol.h
 *
 *  Created on: 14. 4. 2014
 *      Author: tomas
 */

#ifndef GLUSHKOVSYMBOL_H_
#define GLUSHKOVSYMBOL_H_

#include <alphabet/Symbol.h>
#include <regexp/RegExpSymbol.h>

namespace conversions
{

/**
 * Represents numbered symbol in glushkov algorithm.
 */
class GlushkovSymbol
{
private:
    regexp::RegExpSymbol const * const m_regexpSymbol;
    int m_i;

public:
    GlushkovSymbol( regexp::RegExpSymbol const * const & node, int i );
    bool operator<( GlushkovSymbol const& x ) const;
    int getId( void ) const;
    alphabet::Symbol getInputSymbol( void ) const;
    regexp::RegExpSymbol const * const getSymbolPtr( void ) const;
};

} /* namespace conversions */

#endif /* GLUSHKOVSYMBOL_H_ */
